/*!
 * https://github.com/leonardosnt/java-class-tools
 * 
 * Copyright (C) 2017-2019 leonardosnt
 * Licensed under the MIT License. See LICENSE file in the project root for full license information.
 */
 !function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.JavaClassTools=t():e.JavaClassTools=t()}(window,function(){return r={},n.m=i=[function(e,t,i){"use strict";i.r(t);var r=i(1);i.d(t,"JavaClassFileReader",function(){return r.default});var n=i(7);i.d(t,"JavaClassFileWriter",function(){return n.default});var s=i(5);i.d(t,"ConstantType",function(){return s.default});var f=i(8);i.d(t,"Opcode",function(){return f.default});var a=i(9);i.d(t,"Modifier",function(){return a.default});var o=i(10);i.d(t,"Instruction",function(){return o.Instruction}),i.d(t,"InstructionParser",function(){return o.InstructionParser})},function(e,a,o){"use strict";o.r(a),function(i){var e=o(3),r=o.n(e),n=o(5);function s(e){return(s="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function f(e,t){for(var i=0;i<t.length;i++){var r=t[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var t=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,i){t&&f(e.prototype,t),i&&f(e,i)}(e,[{key:"read",value:function(e){if(null==e)throw TypeError("source cannot be null or undefined");if("string"==typeof e)return this.readFromFile(e);if(this.buf=r.a.wrap(e),this.classFile=new function(){},3405691582!==this.buf.readUint32())throw Error("Invalid MAGIC value");this.classFile.minor_version=this.buf.readUint16(),this.classFile.major_version=this.buf.readUint16(),this.classFile.constant_pool_count=this.buf.readUint16(),this.classFile.constant_pool=this._readConstantPool(this.classFile.constant_pool_count-1),this.classFile.access_flags=this.buf.readUint16(),this.classFile.this_class=this.buf.readUint16(),this.classFile.super_class=this.buf.readUint16(),this.classFile.interfaces_count=this.buf.readUint16(),this.classFile.interfaces=this._readInterfaces(this.classFile.interfaces_count),this.classFile.fields_count=this.buf.readUint16(),this.classFile.fields=this._readMemberInfoArray(this.classFile.fields_count),this.classFile.methods_count=this.buf.readUint16(),this.classFile.methods=this._readMemberInfoArray(this.classFile.methods_count),this.classFile.attributes_count=this.buf.readUint16(),this.classFile.attributes=this._readAttributeInfoArray(this.classFile.attributes_count);var t=this.classFile;return delete this.buf,delete this.classFile,t}},{key:"readFromFile",value:function(e){if(void 0===(void 0===i?"undefined":s(i)))throw Error("readFromFile is not supported in the browser.");var t=o(6);return this.read(t.readFileSync(e))}},{key:"_readMemberInfoArray",value:function(e){for(var t=new Array(e),i=0;i<e;i++){var r={access_flags:this.buf.readUint16(),name_index:this.buf.readUint16(),descriptor_index:this.buf.readUint16(),attributes_count:this.buf.readUint16()};r.attributes=this._readAttributeInfoArray(r.attributes_count),t[i]=r}return t}},{key:"_readAttributeInfoArray",value:function(e){for(var t=new Array(e),i=0;i<e;i++)t[i]=this._readAttributeInfo();return t}},{key:"_readVerificationTypeInfo",value:function(){var e={tag:this.buf.readUint8()};return 7===e.tag?e.cpool_index=this.buf.readUint16():8===e.tag&&(e.offset=this.buf.readUint16()),e}},{key:"_readTypeAnnotation",value:function(){var e={target_type:this.buf.readUint8(),target_info:{}};switch(e.target_type){case 0:case 1:e.target_info.type_parameter_index=this.buf.readUint8();break;case 16:e.target_info.supertype_index=this.buf.readUint16();break;case 17:case 18:e.target_info.type_parameter_index=this.buf.readUint8(),e.target_info.bound_index=this.buf.readUint8();break;case 19:case 20:case 21:break;case 22:e.target_info.formal_parameter_index=this.buf.readUint8();break;case 23:e.target_info.throws_type_index=this.buf.readUint16();break;case 64:case 65:e.target_info.table_length=this.buf.readUint16(),e.target_info.table=new Array(e.target_info.table_length);for(var t=0;t<e.target_info.table_length;t++){var i={start_pc:this.buf.readUint16(),length:this.buf.readUint16(),index:this.buf.readUint16()};e.target_info.table[t]=i}break;case 66:e.target_info.exception_table_index=this.buf.readUint16();break;case 67:case 68:case 69:case 70:e.target_info.offset=this.buf.readUint16();break;case 71:case 72:case 73:case 74:case 75:e.target_info.offset=this.buf.readUint16(),e.target_info.type_argument_index=this.buf.readUint8();break;default:throw Error("Unexpected target_type: ".concat(e.target_type))}e.type_path={path_length:this.buf.readUint8()},e.type_path.path=new Array(e.type_path.path_length);for(var r=0;r<e.type_path.path_length;r++)e.type_path.path[r]={type_path_kind:this.buf.readUint8(),type_argument_index:this.buf.readUint8()};e.type_index=this.buf.readUint16(),e.num_element_value_pairs=this.buf.readUint16(),e.element_value_pairs=new Array(e.num_element_value_pairs);for(var n=0;n<e.num_element_value_pairs;n++)e.element_value_pairs[n]={element_name_index:this.buf.readUint16(),element_value:this._readElementValue()};return e}},{key:"_readAttributeInfo",value:function(){var e={attribute_name_index:this.buf.readUint16(),attribute_length:this.buf.readUint32()},t=this.classFile.constant_pool[e.attribute_name_index].bytes;switch(String.fromCharCode.apply(null,t)){case"Deprecated":case"Synthetic":break;case"RuntimeInvisibleAnnotations":case"RuntimeVisibleAnnotations":e.num_annotations=this.buf.readUint16(),e.annotations=new Array(e.num_annotations);for(var i=0;i<e.num_annotations;i++)e.annotations[i]=this._readAttributeAnnotation();break;case"InnerClasses":e.number_of_classes=this.buf.readUint16(),e.classes=new Array(e.number_of_classes);for(var r=0;r<e.number_of_classes;r++)e.classes[r]={inner_class_info_index:this.buf.readUint16(),outer_class_info_index:this.buf.readUint16(),inner_name_index:this.buf.readUint16(),inner_class_access_flags:this.buf.readUint16()};break;case"LocalVariableTable":e.local_variable_table_length=this.buf.readUint16(),e.local_variable_table=new Array(e.local_variable_table_length);for(var n=0;n<e.local_variable_table_length;n++)e.local_variable_table[n]={start_pc:this.buf.readUint16(),length:this.buf.readUint16(),name_index:this.buf.readUint16(),descriptor_index:this.buf.readUint16(),index:this.buf.readUint16()};break;case"LocalVariableTypeTable":e.local_variable_type_table_length=this.buf.readUint16(),e.local_variable_type_table=new Array(e.local_variable_type_table_length);for(var s=0;s<e.local_variable_type_table_length;s++)e.local_variable_type_table[s]={start_pc:this.buf.readUint16(),length:this.buf.readUint16(),name_index:this.buf.readUint16(),signature_index:this.buf.readUint16(),index:this.buf.readUint16()};break;case"RuntimeInvisibleParameterAnnotations":case"RuntimeVisibleParameterAnnotations":e.num_parameters=this.buf.readUint8(),e.parameter_annotations=new Array(e.num_parameters);for(var f=0;f<e.num_parameters;f++){var a={num_annotations:this.buf.readUint16()};a.annotations=new Array(a.num_annotations);for(var o=0;o<a.num_annotations;o++)a.annotations[o]=this._readAttributeAnnotation();e.parameter_annotations[f]=a}break;case"BootstrapMethods":e.num_bootstrap_methods=this.buf.readUint16(),e.bootstrap_methods=new Array(e.num_bootstrap_methods);for(var u=0;u<e.num_bootstrap_methods;u++){var h={bootstrap_method_ref:this.buf.readUint16(),num_bootstrap_arguments:this.buf.readUint16()};h.bootstrap_arguments=new Array(h.num_bootstrap_arguments);for(var l=0;l<h.num_bootstrap_arguments;l++)h.bootstrap_arguments[l]=this.buf.readUint16();e.bootstrap_methods[u]=h}break;case"RuntimeInvisibleTypeAnnotations":case"RuntimeVisibleTypeAnnotations":e.num_annotations=this.buf.readUint16(),e.annotations=new Array(e.num_annotations);for(var b=0;b<e.num_annotations;b++)e.annotations[b]=this._readTypeAnnotation();break;case"SourceDebugExtension":e.debug_extension=new Array(e.attribute_length);for(var c=0;c<e.attribute_length;c++)e.debug_extension[c]=this.buf.readUint8();break;case"SourceFile":e.sourcefile_index=this.buf.readUint16();break;case"EnclosingMethod":e.class_index=this.buf.readUint16(),e.method_index=this.buf.readUint16();break;case"AnnotationDefault":e.default_value=this._readElementValue();break;case"MethodParameters":e.parameters_count=this.buf.readUint8(),e.parameters=new Array(e.parameters_count);for(var d=0;d<e.parameters_count;d++)e.parameters[d]={name_index:this.buf.readUint16(),access_flags:this.buf.readUint16()};break;case"ConstantValue":e.constantvalue_index=this.buf.readUint16();break;case"Signature":e.signature_index=this.buf.readUint16();break;case"StackMap":return this._readStackMapAttribute(e);case"Exceptions":return this._readExceptionsAttribute(e);case"StackMapTable":return this._readStackMapTableAttribute(e);case"Code":return this._readCodeAttribute(e);case"LineNumberTable":return this._readLineNumberTableAttribute(e);case"Module":return this._readModuleAttribute(e);case"ModulePackages":return this._readModulePackagesAttribute(e);case"ModuleMainClass":e.main_class_index=this.buf.readUint16();break;case"NestHost":e.host_class_index=this.buf.readUint16();break;case"NestMembers":e.number_of_classes=this.buf.readUint16(),e.classes=new Array(e.number_of_classes);for(var _=0;_<e.number_of_classes;_++)e.classes[_]=this.buf.readUint16();break;default:e.info=new Array(e.attribute_length);for(var g=0;g<e.attribute_length;g++)e.info[g]=this.buf.readUint8()}return e}},{key:"_readCodeAttribute",value:function(e){e.max_stack=this.buf.readUint16(),e.max_locals=this.buf.readUint16(),e.code_length=this.buf.readUint32(),e.code=new Array(e.code_length);for(var t=0;t<e.code_length;t++)e.code[t]=this.buf.readUint8();e.exception_table_length=this.buf.readUint16(),e.exception_table=new Array(e.exception_table_length);for(var i=0;i<e.exception_table_length;i++)e.exception_table[i]={start_pc:this.buf.readUint16(),end_pc:this.buf.readUint16(),handler_pc:this.buf.readUint16(),catch_type:this.buf.readUint16()};return e.attributes_count=this.buf.readUint16(),e.attributes=this._readAttributeInfoArray(e.attributes_count),e}},{key:"_readLineNumberTableAttribute",value:function(e){e.line_number_table_length=this.buf.readUint16(),e.line_number_table=new Array(e.line_number_table_length);for(var t=0;t<e.line_number_table_length;t++)e.line_number_table[t]={start_pc:this.buf.readUint16(),line_number:this.buf.readUint16()};return e}},{key:"_readStackMapTableAttribute",value:function(e){e.number_of_entries=this.buf.readUint16(),e.entries=new Array(e.number_of_entries);for(var t=0;t<e.number_of_entries;t++){var i={frame_type:this.buf.readUint8()},r=i.frame_type;if(0<=r&&r<=63)e.entries[t]=i;else{if(64<=r&&r<=127)i.stack=[this._readVerificationTypeInfo()];else if(247===i.frame_type)i.offset_delta=this.buf.readUint16(),i.stack=[this._readVerificationTypeInfo()];else if(248<=r&&r<=251)i.offset_delta=this.buf.readUint16();else if(252<=r&&r<=254){var n=r-251;i.offset_delta=this.buf.readUint16(),i.locals=new Array(n);for(var s=0;s<n;s++)i.locals[s]=this._readVerificationTypeInfo()}else if(255===r){i.offset_delta=this.buf.readUint16(),i.number_of_locals=this.buf.readUint16(),i.locals=new Array(i.number_of_locals);for(var f=0;f<i.number_of_locals;f++)i.locals[f]=this._readVerificationTypeInfo();i.number_of_stack_items=this.buf.readUint16(),i.stack=new Array(i.number_of_stack_items);for(var a=0;a<i.number_of_stack_items;a++)i.stack[a]=this._readVerificationTypeInfo()}e.entries[t]=i}}return e}},{key:"_readExceptionsAttribute",value:function(e){e.number_of_exceptions=this.buf.readUint16(),e.exception_index_table=new Array(e.number_of_exceptions);for(var t=0;t<e.number_of_exceptions;t++)e.exception_index_table[t]=this.buf.readUint16();return e}},{key:"_readStackMapAttribute",value:function(e){e.number_of_entries=this.buf.readUint16(),e.entries=new Array(e.number_of_entries);for(var t=0;t<e.number_of_entries;t++){var i={offset:this.buf.readUint16()};i.number_of_locals=this.buf.readUint16(),i.locals=new Array(i.number_of_locals);for(var r=0;r<i.number_of_locals;r++)i.locals[r]=this._readVerificationTypeInfo();i.number_of_stack_items=this.buf.readUint16(),i.stack=new Array(i.number_of_stack_items);for(var n=0;n<i.number_of_stack_items;n++)i.stack[n]=this._readVerificationTypeInfo();e.entries[t]=i}return e}},{key:"_readModuleAttribute",value:function(e){e.module_name_index=this.buf.readUint16(),e.module_flags=this.buf.readUint16(),e.module_version_index=this.buf.readUint16(),e.requires_count=this.buf.readUint16(),e.requires=new Array(e.requires_count);for(var t=0;t<e.requires_count;t++)e.requires[t]={requires_index:this.buf.readUint16(),requires_flags:this.buf.readUint16(),requires_version_index:this.buf.readUint16()};e.exports_count=this.buf.readUint16(),e.exports=new Array(e.exports_count);for(var i=0;i<e.exports_count;i++){var r={exports_index:this.buf.readUint16(),exports_flags:this.buf.readUint16(),exports_to_count:this.buf.readUint16()};r.exports_to_index=new Array(r.exports_to_count);for(var n=0;n<r.exports_to_count;n++)r.exports_to_index[n]=this.buf.readUint16();e.exports[i]=r}e.opens_count=this.buf.readUint16(),e.opens=new Array(e.opens_count);for(var s=0;s<e.opens_count;s++){var f={opens_index:this.buf.readUint16(),opens_flags:this.buf.readUint16(),opens_to_count:this.buf.readUint16()};f.opens_to_index=new Array(f.opens_to_count);for(var a=0;a<f.opens_to_count;a++)f.opens_to_index[a]=this.buf.readUint16();e.opens[s]=f}e.uses_count=this.buf.readUint16(),e.uses_index=new Array(e.uses_count);for(var o=0;o<e.uses_count;o++)e.uses_index[o]=this.buf.readUint16();e.provides_count=this.buf.readUint16(),e.provides=new Array(e.provides_count);for(var u=0;u<e.provides_count;u++){var h={provides_index:this.buf.readUint16(),provides_with_count:this.buf.readUint16()};h.provides_with_index=new Array(h.provides_with_count);for(var l=0;l<h.provides_with_count;l++)h.provides_with_index[l]=this.buf.readUint16();e.provides[u]=h}return e}},{key:"_readModulePackagesAttribute",value:function(e){e.package_count=this.buf.readUint16(),e.package_index=new Array(e.package_count);for(var t=0;t<e.package_count;t++)e.package_index[t]=this.buf.readUint16();return e}},{key:"_readAttributeAnnotation",value:function(){var e={type_index:this.buf.readUint16(),num_element_value_pairs:this.buf.readUint16()};e.element_value_pairs=new Array(e.num_element_value_pairs);for(var t=0;t<e.num_element_value_pairs;t++)e.element_value_pairs[t]={element_name_index:this.buf.readUint16(),element_value:this._readElementValue()};return e}},{key:"_readElementValue",value:function(){var e={tag:this.buf.readUint8(),value:{}};switch(e.tag){case 101:e.value.enum_const_value={type_name_index:this.buf.readUint16(),const_name_index:this.buf.readUint16()};break;case 99:e.value.class_info_index=this.buf.readUint16();break;case 91:for(var t=this.buf.readUint16(),i=new Array(t),r=0;r<t;r++)i[r]=this._readElementValue();e.value.array_value={num_values:t,values:i};break;case 64:e.value.annotation=this._readAttributeAnnotation();break;case 66:case 67:case 68:case 70:case 73:case 74:case 83:case 90:case 115:e.value.const_value_index=this.buf.readUint16();break;default:throw Error("Unexpected tag: ".concat(e.tag))}return e}},{key:"_readInterfaces",value:function(e){for(var t=new Array(e),i=0;i<e;i++)t[i]=this.buf.readUint16();return t}},{key:"_readConstantPool",value:function(e){for(var t=new Array(e),i=1;i<=e;i++){var r=this._readConstantPoolEntry();(t[i]=r).tag!==n.default.LONG&&r.tag!==n.default.DOUBLE||(t[++i]=void 0)}return t}},{key:"_readUtf8PoolEntry",value:function(e){for(var t=this.buf.readUint16(),i=new Array(t),r=0;r<t;r++)i[r]=this.buf.readUint8();return{tag:e,length:t,bytes:i}}},{key:"_readConstantPoolEntry",value:function(){var e=this.buf.readUint8();switch(e){case n.default.UTF8:return this._readUtf8PoolEntry(e);case n.default.INTEGER:case n.default.FLOAT:return{tag:e,bytes:this.buf.readUint32()};case n.default.LONG:case n.default.DOUBLE:return{tag:e,high_bytes:this.buf.readUint32(),low_bytes:this.buf.readUint32()};case n.default.PACKAGE:case n.default.MODULE:case n.default.CLASS:return{tag:e,name_index:this.buf.readUint16()};case n.default.STRING:return{tag:e,string_index:this.buf.readUint16()};case n.default.FIELDREF:case n.default.METHODREF:case n.default.INTERFACE_METHODREF:return{tag:e,class_index:this.buf.readUint16(),name_and_type_index:this.buf.readUint16()};case n.default.NAME_AND_TYPE:return{tag:e,name_index:this.buf.readUint16(),descriptor_index:this.buf.readUint16()};case n.default.METHOD_HANDLE:return{tag:e,reference_kind:this.buf.readUint8(),reference_index:this.buf.readUint16()};case n.default.METHOD_TYPE:return{tag:e,descriptor_index:this.buf.readUint16()};case n.default.DYNAMIC:case n.default.INVOKE_DYNAMIC:return{tag:e,bootstrap_method_attr_index:this.buf.readUint16(),name_and_type_index:this.buf.readUint16()};default:throw Error("Unexpected tag: ".concat(e))}}}]),e}();a.default=t}.call(this,o(2))},function(e,t){var i,r,n=e.exports={};function s(){throw new Error("setTimeout has not been defined")}function f(){throw new Error("clearTimeout has not been defined")}function a(t){if(i===setTimeout)return setTimeout(t,0);if((i===s||!i)&&setTimeout)return i=setTimeout,setTimeout(t,0);try{return i(t,0)}catch(e){try{return i.call(null,t,0)}catch(e){return i.call(this,t,0)}}}!function(){try{i="function"==typeof setTimeout?setTimeout:s}catch(e){i=s}try{r="function"==typeof clearTimeout?clearTimeout:f}catch(e){r=f}}();var o,u=[],h=!1,l=-1;function b(){h&&o&&(h=!1,o.length?u=o.concat(u):l=-1,u.length&&c())}function c(){if(!h){var e=a(b);h=!0;for(var t=u.length;t;){for(o=u,u=[];++l<t;)o&&o[l].run();l=-1,t=u.length}o=null,h=!1,function(t){if(r===clearTimeout)return clearTimeout(t);if((r===f||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(t);try{r(t)}catch(e){try{return r.call(null,t)}catch(e){return r.call(this,t)}}}(e)}}function d(e,t){this.fun=e,this.array=t}function _(){}n.nextTick=function(e){var t=new Array(arguments.length-1);if(1<arguments.length)for(var i=1;i<arguments.length;i++)t[i-1]=arguments[i];u.push(new d(e,t)),1!==u.length||h||a(c)},d.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=_,n.addListener=_,n.once=_,n.off=_,n.removeListener=_,n.removeAllListeners=_,n.emit=_,n.prependListener=_,n.prependOnceListener=_,n.listeners=function(e){return[]},n.binding=function(e){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(e){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}},function(e,t,i){var r,n,s;n=[i(4)],void 0===(s="function"==typeof(r=function(o){"use strict";var d=function(e,t,i){if(typeof e==="undefined")e=d.DEFAULT_CAPACITY;if(typeof t==="undefined")t=d.DEFAULT_ENDIAN;if(typeof i==="undefined")i=d.DEFAULT_NOASSERT;if(!i){e=e|0;if(e<0)throw RangeError("Illegal capacity");t=!!t;i=!!i}this.buffer=e===0?s:new ArrayBuffer(e);this.view=e===0?null:new Uint8Array(this.buffer);this.offset=0;this.markedOffset=-1;this.limit=e;this.littleEndian=t;this.noAssert=i};d.VERSION="5.0.1",d.LITTLE_ENDIAN=true,d.BIG_ENDIAN=false,d.DEFAULT_CAPACITY=16,d.DEFAULT_ENDIAN=d.BIG_ENDIAN,d.DEFAULT_NOASSERT=false,d.Long=o||null;var f=d.prototype;f.__isByteBuffer__,Object.defineProperty(f,"__isByteBuffer__",{value:true,enumerable:false,configurable:false});var s=new ArrayBuffer(0),i=String.fromCharCode;function a(e){var t=0;return function(){return t<e.length?e.charCodeAt(t++):null}}function u(){var e=[],t=[];return function(){if(arguments.length===0)return t.join("")+i.apply(String,e);if(e.length+arguments.length>1024)t.push(i.apply(String,e)),e.length=0;Array.prototype.push.apply(e,arguments)}}if(d.accessor=function(){return Uint8Array},d.allocate=function(e,t,i){return new d(e,t,i)},d.concat=function(e,t,i,r){if(typeof t==="boolean"||typeof t!=="string"){r=i;i=t;t=undefined}var n=0;for(var s=0,f=e.length,a;s<f;++s){if(!d.isByteBuffer(e[s]))e[s]=d.wrap(e[s],t);a=e[s].limit-e[s].offset;if(a>0)n+=a}if(n===0)return new d(0,i,r);var o=new d(n,i,r),u;s=0;while(s<f){u=e[s++];a=u.limit-u.offset;if(a<=0)continue;o.view.set(u.view.subarray(u.offset,u.limit),o.offset);o.offset+=a}o.limit=o.offset;o.offset=0;return o},d.isByteBuffer=function(e){return(e&&e["__isByteBuffer__"])===true},d.type=function(){return ArrayBuffer},d.wrap=function(e,t,i,r){if(typeof t!=="string"){r=i;i=t;t=undefined}if(typeof e==="string"){if(typeof t==="undefined")t="utf8";switch(t){case"base64":return d.fromBase64(e,i);case"hex":return d.fromHex(e,i);case"binary":return d.fromBinary(e,i);case"utf8":return d.fromUTF8(e,i);case"debug":return d.fromDebug(e,i);default:throw Error("Unsupported encoding: "+t)}}if(e===null||typeof e!=="object")throw TypeError("Illegal buffer");var n;if(d.isByteBuffer(e)){n=f.clone.call(e);n.markedOffset=-1;return n}if(e instanceof Uint8Array){n=new d(0,i,r);if(e.length>0){n.buffer=e.buffer;n.offset=e.byteOffset;n.limit=e.byteOffset+e.byteLength;n.view=new Uint8Array(e.buffer)}}else if(e instanceof ArrayBuffer){n=new d(0,i,r);if(e.byteLength>0){n.buffer=e;n.offset=0;n.limit=e.byteLength;n.view=e.byteLength>0?new Uint8Array(e):null}}else if(Object.prototype.toString.call(e)==="[object Array]"){n=new d(e.length,i,r);n.limit=e.length;for(var s=0;s<e.length;++s)n.view[s]=e[s]}else throw TypeError("Illegal buffer");return n},f.writeBitSet=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(!(e instanceof Array))throw TypeError("Illegal BitSet: Not an array");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}var r=t,n=e.length,s=n>>3,f=0,a;t+=this.writeVarint32(n,t);while(s--){a=!!e[f++]&1|(!!e[f++]&1)<<1|(!!e[f++]&1)<<2|(!!e[f++]&1)<<3|(!!e[f++]&1)<<4|(!!e[f++]&1)<<5|(!!e[f++]&1)<<6|(!!e[f++]&1)<<7;this.writeByte(a,t++)}if(f<n){var o=0;a=0;while(f<n)a=a|(!!e[f++]&1)<<o++;this.writeByte(a,t++)}if(i){this.offset=t;return this}return t-r},f.readBitSet=function(e){var t=typeof e==="undefined";if(t)e=this.offset;var i=this.readVarint32(e),r=i.value,n=r>>3,s=0,f=[],a;e+=i.length;while(n--){a=this.readByte(e++);f[s++]=!!(a&1);f[s++]=!!(a&2);f[s++]=!!(a&4);f[s++]=!!(a&8);f[s++]=!!(a&16);f[s++]=!!(a&32);f[s++]=!!(a&64);f[s++]=!!(a&128)}if(s<r){var o=0;a=this.readByte(e++);while(s<r)f[s++]=!!(a>>o++&1)}if(t){this.offset=e}return f},f.readBytes=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+e>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+e+") <= "+this.buffer.byteLength)}var r=this.slice(t,t+e);if(i)this.offset+=e;return r},f.writeBytes=f.append,f.writeInt8=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e|=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=1;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=1;this.view[t]=e;if(i)this.offset+=1;return this},f.writeByte=f.writeInt8,f.readInt8=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=this.view[e];if((i&128)===128)i=-(255-i+1);if(t)this.offset+=1;return i},f.readByte=f.readInt8,f.writeUint8=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=1;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=1;this.view[t]=e;if(i)this.offset+=1;return this},f.writeUInt8=f.writeUint8,f.readUint8=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=this.view[e];if(t)this.offset+=1;return i},f.readUInt8=f.readUint8,f.writeInt16=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e|=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=2;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=2;if(this.littleEndian){this.view[t+1]=(e&65280)>>>8;this.view[t]=e&255}else{this.view[t]=(e&65280)>>>8;this.view[t+1]=e&255}if(i)this.offset+=2;return this},f.writeShort=f.writeInt16,f.readInt16=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+2>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+2+") <= "+this.buffer.byteLength)}var i=0;if(this.littleEndian){i=this.view[e];i|=this.view[e+1]<<8}else{i=this.view[e]<<8;i|=this.view[e+1]}if((i&32768)===32768)i=-(65535-i+1);if(t)this.offset+=2;return i},f.readShort=f.readInt16,f.writeUint16=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=2;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=2;if(this.littleEndian){this.view[t+1]=(e&65280)>>>8;this.view[t]=e&255}else{this.view[t]=(e&65280)>>>8;this.view[t+1]=e&255}if(i)this.offset+=2;return this},f.writeUInt16=f.writeUint16,f.readUint16=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+2>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+2+") <= "+this.buffer.byteLength)}var i=0;if(this.littleEndian){i=this.view[e];i|=this.view[e+1]<<8}else{i=this.view[e]<<8;i|=this.view[e+1]}if(t)this.offset+=2;return i},f.readUInt16=f.readUint16,f.writeInt32=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e|=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=4;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=4;if(this.littleEndian){this.view[t+3]=e>>>24&255;this.view[t+2]=e>>>16&255;this.view[t+1]=e>>>8&255;this.view[t]=e&255}else{this.view[t]=e>>>24&255;this.view[t+1]=e>>>16&255;this.view[t+2]=e>>>8&255;this.view[t+3]=e&255}if(i)this.offset+=4;return this},f.writeInt=f.writeInt32,f.readInt32=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+4>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+4+") <= "+this.buffer.byteLength)}var i=0;if(this.littleEndian){i=this.view[e+2]<<16;i|=this.view[e+1]<<8;i|=this.view[e];i+=this.view[e+3]<<24>>>0}else{i=this.view[e+1]<<16;i|=this.view[e+2]<<8;i|=this.view[e+3];i+=this.view[e]<<24>>>0}i|=0;if(t)this.offset+=4;return i},f.readInt=f.readInt32,f.writeUint32=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=4;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=4;if(this.littleEndian){this.view[t+3]=e>>>24&255;this.view[t+2]=e>>>16&255;this.view[t+1]=e>>>8&255;this.view[t]=e&255}else{this.view[t]=e>>>24&255;this.view[t+1]=e>>>16&255;this.view[t+2]=e>>>8&255;this.view[t+3]=e&255}if(i)this.offset+=4;return this},f.writeUInt32=f.writeUint32,f.readUint32=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+4>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+4+") <= "+this.buffer.byteLength)}var i=0;if(this.littleEndian){i=this.view[e+2]<<16;i|=this.view[e+1]<<8;i|=this.view[e];i+=this.view[e+3]<<24>>>0}else{i=this.view[e+1]<<16;i|=this.view[e+2]<<8;i|=this.view[e+3];i+=this.view[e]<<24>>>0}if(t)this.offset+=4;return i},f.readUInt32=f.readUint32,o){f.writeInt64=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);else if(!(e&&e instanceof o))throw TypeError("Illegal value: "+e+" (not an integer or Long)");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);t+=8;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=8;var n=e.low,s=e.high;if(this.littleEndian){this.view[t+3]=n>>>24&255;this.view[t+2]=n>>>16&255;this.view[t+1]=n>>>8&255;this.view[t]=n&255;t+=4;this.view[t+3]=s>>>24&255;this.view[t+2]=s>>>16&255;this.view[t+1]=s>>>8&255;this.view[t]=s&255}else{this.view[t]=s>>>24&255;this.view[t+1]=s>>>16&255;this.view[t+2]=s>>>8&255;this.view[t+3]=s&255;t+=4;this.view[t]=n>>>24&255;this.view[t+1]=n>>>16&255;this.view[t+2]=n>>>8&255;this.view[t+3]=n&255}if(i)this.offset+=8;return this};f.writeLong=f.writeInt64;f.readInt64=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+8>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+8+") <= "+this.buffer.byteLength)}var i=0,r=0;if(this.littleEndian){i=this.view[e+2]<<16;i|=this.view[e+1]<<8;i|=this.view[e];i+=this.view[e+3]<<24>>>0;e+=4;r=this.view[e+2]<<16;r|=this.view[e+1]<<8;r|=this.view[e];r+=this.view[e+3]<<24>>>0}else{r=this.view[e+1]<<16;r|=this.view[e+2]<<8;r|=this.view[e+3];r+=this.view[e]<<24>>>0;e+=4;i=this.view[e+1]<<16;i|=this.view[e+2]<<8;i|=this.view[e+3];i+=this.view[e]<<24>>>0}var n=new o(i,r,false);if(t)this.offset+=8;return n};f.readLong=f.readInt64;f.writeUint64=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);else if(!(e&&e instanceof o))throw TypeError("Illegal value: "+e+" (not an integer or Long)");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);t+=8;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=8;var n=e.low,s=e.high;if(this.littleEndian){this.view[t+3]=n>>>24&255;this.view[t+2]=n>>>16&255;this.view[t+1]=n>>>8&255;this.view[t]=n&255;t+=4;this.view[t+3]=s>>>24&255;this.view[t+2]=s>>>16&255;this.view[t+1]=s>>>8&255;this.view[t]=s&255}else{this.view[t]=s>>>24&255;this.view[t+1]=s>>>16&255;this.view[t+2]=s>>>8&255;this.view[t+3]=s&255;t+=4;this.view[t]=n>>>24&255;this.view[t+1]=n>>>16&255;this.view[t+2]=n>>>8&255;this.view[t+3]=n&255}if(i)this.offset+=8;return this};f.writeUInt64=f.writeUint64;f.readUint64=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+8>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+8+") <= "+this.buffer.byteLength)}var i=0,r=0;if(this.littleEndian){i=this.view[e+2]<<16;i|=this.view[e+1]<<8;i|=this.view[e];i+=this.view[e+3]<<24>>>0;e+=4;r=this.view[e+2]<<16;r|=this.view[e+1]<<8;r|=this.view[e];r+=this.view[e+3]<<24>>>0}else{r=this.view[e+1]<<16;r|=this.view[e+2]<<8;r|=this.view[e+3];r+=this.view[e]<<24>>>0;e+=4;i=this.view[e+1]<<16;i|=this.view[e+2]<<8;i|=this.view[e+3];i+=this.view[e]<<24>>>0}var n=new o(i,r,true);if(t)this.offset+=8;return n};f.readUInt64=f.readUint64}function r(e,t,i,r,n){var s,f,a=n*8-r-1,o=(1<<a)-1,u=o>>1,h=-7,l=i?n-1:0,b=i?-1:1,c=e[t+l];l+=b;s=c&(1<<-h)-1;c>>=-h;h+=a;for(;h>0;s=s*256+e[t+l],l+=b,h-=8){}f=s&(1<<-h)-1;s>>=-h;h+=r;for(;h>0;f=f*256+e[t+l],l+=b,h-=8){}if(s===0){s=1-u}else if(s===o){return f?NaN:(c?-1:1)*Infinity}else{f=f+Math.pow(2,r);s=s-u}return(c?-1:1)*f*Math.pow(2,s-r)}function n(e,t,i,r,n,s){var f,a,o,u=s*8-n-1,h=(1<<u)-1,l=h>>1,b=n===23?Math.pow(2,-24)-Math.pow(2,-77):0,c=r?0:s-1,d=r?1:-1,_=t<0||t===0&&1/t<0?1:0;t=Math.abs(t);if(isNaN(t)||t===Infinity){a=isNaN(t)?1:0;f=h}else{f=Math.floor(Math.log(t)/Math.LN2);if(t*(o=Math.pow(2,-f))<1){f--;o*=2}if(f+l>=1){t+=b/o}else{t+=b*Math.pow(2,1-l)}if(t*o>=2){f++;o/=2}if(f+l>=h){a=0;f=h}else if(f+l>=1){a=(t*o-1)*Math.pow(2,n);f=f+l}else{a=t*Math.pow(2,l-1)*Math.pow(2,n);f=0}}for(;n>=8;e[i+c]=a&255,c+=d,a/=256,n-=8){}f=f<<n|a;u+=n;for(;u>0;e[i+c]=f&255,c+=d,f/=256,u-=8){}e[i+c-d]|=_*128}if(f.writeFloat32=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number")throw TypeError("Illegal value: "+e+" (not a number)");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=4;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=4;n(this.view,e,t,this.littleEndian,23,4);if(i)this.offset+=4;return this},f.writeFloat=f.writeFloat32,f.readFloat32=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+4>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+4+") <= "+this.buffer.byteLength)}var i=r(this.view,e,this.littleEndian,23,4);if(t)this.offset+=4;return i},f.readFloat=f.readFloat32,f.writeFloat64=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number")throw TypeError("Illegal value: "+e+" (not a number)");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}t+=8;var r=this.buffer.byteLength;if(t>r)this.resize((r*=2)>t?r:t);t-=8;n(this.view,e,t,this.littleEndian,52,8);if(i)this.offset+=8;return this},f.writeDouble=f.writeFloat64,f.readFloat64=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+8>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+8+") <= "+this.buffer.byteLength)}var i=r(this.view,e,this.littleEndian,52,8);if(t)this.offset+=8;return i},f.readDouble=f.readFloat64,d.MAX_VARINT32_BYTES=5,d.calculateVarint32=function(e){e=e>>>0;if(e<1<<7)return 1;else if(e<1<<14)return 2;else if(e<1<<21)return 3;else if(e<1<<28)return 4;else return 5},d.zigZagEncode32=function(e){return((e|=0)<<1^e>>31)>>>0},d.zigZagDecode32=function(e){return e>>>1^-(e&1)|0},f.writeVarint32=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e|=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}var r=d.calculateVarint32(e),n;t+=r;var s=this.buffer.byteLength;if(t>s)this.resize((s*=2)>t?s:t);t-=r;e>>>=0;while(e>=128){n=e&127|128;this.view[t++]=n;e>>>=7}this.view[t++]=e;if(i){this.offset=t;return this}return r},f.writeVarint32ZigZag=function(e,t){return this.writeVarint32(d.zigZagEncode32(e),t)},f.readVarint32=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=0,r=0>>>0,n;do{if(!this.noAssert&&e>this.limit){var s=Error("Truncated");s["truncated"]=true;throw s}n=this.view[e++];if(i<5)r|=(n&127)<<7*i;++i}while((n&128)!==0);r|=0;if(t){this.offset=e;return r}return{value:r,length:i}},f.readVarint32ZigZag=function(e){var t=this.readVarint32(e);if(typeof t==="object")t["value"]=d.zigZagDecode32(t["value"]);else t=d.zigZagDecode32(t);return t},o){d.MAX_VARINT64_BYTES=10;d.calculateVarint64=function(e){if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);var t=e.toInt()>>>0,i=e.shiftRightUnsigned(28).toInt()>>>0,r=e.shiftRightUnsigned(56).toInt()>>>0;if(r==0){if(i==0){if(t<1<<14)return t<1<<7?1:2;else return t<1<<21?3:4}else{if(i<1<<14)return i<1<<7?5:6;else return i<1<<21?7:8}}else return r<1<<7?9:10};d.zigZagEncode64=function(e){if(typeof e==="number")e=o.fromNumber(e,false);else if(typeof e==="string")e=o.fromString(e,false);else if(e.unsigned!==false)e=e.toSigned();return e.shiftLeft(1).xor(e.shiftRight(63)).toUnsigned()};d.zigZagDecode64=function(e){if(typeof e==="number")e=o.fromNumber(e,false);else if(typeof e==="string")e=o.fromString(e,false);else if(e.unsigned!==false)e=e.toSigned();return e.shiftRightUnsigned(1).xor(e.and(o.ONE).toSigned().negate()).toSigned()};f.writeVarint64=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e==="number")e=o.fromNumber(e);else if(typeof e==="string")e=o.fromString(e);else if(!(e&&e instanceof o))throw TypeError("Illegal value: "+e+" (not an integer or Long)");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}if(typeof e==="number")e=o.fromNumber(e,false);else if(typeof e==="string")e=o.fromString(e,false);else if(e.unsigned!==false)e=e.toSigned();var r=d.calculateVarint64(e),n=e.toInt()>>>0,s=e.shiftRightUnsigned(28).toInt()>>>0,f=e.shiftRightUnsigned(56).toInt()>>>0;t+=r;var a=this.buffer.byteLength;if(t>a)this.resize((a*=2)>t?a:t);t-=r;switch(r){case 10:this.view[t+9]=f>>>7&1;case 9:this.view[t+8]=r!==9?f|128:f&127;case 8:this.view[t+7]=r!==8?s>>>21|128:s>>>21&127;case 7:this.view[t+6]=r!==7?s>>>14|128:s>>>14&127;case 6:this.view[t+5]=r!==6?s>>>7|128:s>>>7&127;case 5:this.view[t+4]=r!==5?s|128:s&127;case 4:this.view[t+3]=r!==4?n>>>21|128:n>>>21&127;case 3:this.view[t+2]=r!==3?n>>>14|128:n>>>14&127;case 2:this.view[t+1]=r!==2?n>>>7|128:n>>>7&127;case 1:this.view[t]=r!==1?n|128:n&127}if(i){this.offset+=r;return this}else{return r}};f.writeVarint64ZigZag=function(e,t){return this.writeVarint64(d.zigZagEncode64(e),t)};f.readVarint64=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=e,r=0,n=0,s=0,f=0;f=this.view[e++];r=f&127;if(f&128){f=this.view[e++];r|=(f&127)<<7;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];r|=(f&127)<<14;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];r|=(f&127)<<21;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];n=f&127;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];n|=(f&127)<<7;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];n|=(f&127)<<14;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];n|=(f&127)<<21;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];s=f&127;if(f&128||this.noAssert&&typeof f==="undefined"){f=this.view[e++];s|=(f&127)<<7;if(f&128||this.noAssert&&typeof f==="undefined"){throw Error("Buffer overrun")}}}}}}}}}}var a=o.fromBits(r|n<<28,n>>>4|s<<24,false);if(t){this.offset=e;return a}else{return{value:a,length:e-i}}};f.readVarint64ZigZag=function(e){var t=this.readVarint64(e);if(t&&t["value"]instanceof o)t["value"]=d.zigZagDecode64(t["value"]);else t=d.zigZagDecode64(t);return t}}f.writeCString=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;var r,n=e.length;if(!this.noAssert){if(typeof e!=="string")throw TypeError("Illegal str: Not a string");for(r=0;r<n;++r){if(e.charCodeAt(r)===0)throw RangeError("Illegal str: Contains NULL-characters")}if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}n=l.calculateUTF16asUTF8(a(e))[1];t+=n+1;var s=this.buffer.byteLength;if(t>s)this.resize((s*=2)>t?s:t);t-=n+1;l.encodeUTF16toUTF8(a(e),function(e){this.view[t++]=e}.bind(this));this.view[t++]=0;if(i){this.offset=t;return this}return n},f.readCString=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=e,r;var n,s=-1;l.decodeUTF8toUTF16(function(){if(s===0)return null;if(e>=this.limit)throw RangeError("Illegal range: Truncated data, "+e+" < "+this.limit);s=this.view[e++];return s===0?null:s}.bind(this),n=u(),true);if(t){this.offset=e;return n()}else{return{string:n(),length:e-i}}},f.writeIString=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="string")throw TypeError("Illegal str: Not a string");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}var r=t,n;n=l.calculateUTF16asUTF8(a(e),this.noAssert)[1];t+=4+n;var s=this.buffer.byteLength;if(t>s)this.resize((s*=2)>t?s:t);t-=4+n;if(this.littleEndian){this.view[t+3]=n>>>24&255;this.view[t+2]=n>>>16&255;this.view[t+1]=n>>>8&255;this.view[t]=n&255}else{this.view[t]=n>>>24&255;this.view[t+1]=n>>>16&255;this.view[t+2]=n>>>8&255;this.view[t+3]=n&255}t+=4;l.encodeUTF16toUTF8(a(e),function(e){this.view[t++]=e}.bind(this));if(t!==r+4+n)throw RangeError("Illegal range: Truncated data, "+t+" == "+(t+4+n));if(i){this.offset=t;return this}return t-r},f.readIString=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+4>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+4+") <= "+this.buffer.byteLength)}var i=e;var r=this.readUint32(e);var n=this.readUTF8String(r,d.METRICS_BYTES,e+=4);e+=n["length"];if(t){this.offset=e;return n["string"]}else{return{string:n["string"],length:e-i}}},d.METRICS_CHARS="c",d.METRICS_BYTES="b",f.writeUTF8String=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}var r;var n=t;r=l.calculateUTF16asUTF8(a(e))[1];t+=r;var s=this.buffer.byteLength;if(t>s)this.resize((s*=2)>t?s:t);t-=r;l.encodeUTF16toUTF8(a(e),function(e){this.view[t++]=e}.bind(this));if(i){this.offset=t;return this}return t-n},f.writeString=f.writeUTF8String,d.calculateUTF8Chars=function(e){return l.calculateUTF16asUTF8(a(e))[0]},d.calculateUTF8Bytes=function(e){return l.calculateUTF16asUTF8(a(e))[1]},d.calculateString=d.calculateUTF8Bytes,f.readUTF8String=function(e,t,i){if(typeof t==="number"){i=t;t=undefined}var r=typeof i==="undefined";if(r)i=this.offset;if(typeof t==="undefined")t=d.METRICS_CHARS;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal length: "+e+" (not an integer)");e|=0;if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal offset: "+i+" (not an integer)");i>>>=0;if(i<0||i+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+i+" (+"+0+") <= "+this.buffer.byteLength)}var n=0,s=i,f;if(t===d.METRICS_CHARS){f=u();l.decodeUTF8(function(){return n<e&&i<this.limit?this.view[i++]:null}.bind(this),function(e){++n;l.UTF8toUTF16(e,f)});if(n!==e)throw RangeError("Illegal range: Truncated data, "+n+" == "+e);if(r){this.offset=i;return f()}else{return{string:f(),length:i-s}}}else if(t===d.METRICS_BYTES){if(!this.noAssert){if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal offset: "+i+" (not an integer)");i>>>=0;if(i<0||i+e>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+i+" (+"+e+") <= "+this.buffer.byteLength)}var a=i+e;l.decodeUTF8toUTF16(function(){return i<a?this.view[i++]:null}.bind(this),f=u(),this.noAssert);if(i!==a)throw RangeError("Illegal range: Truncated data, "+i+" == "+a);if(r){this.offset=i;return f()}else{return{string:f(),length:i-s}}}else throw TypeError("Unsupported metrics: "+t)},f.readString=f.readUTF8String,f.writeVString=function(e,t){var i=typeof t==="undefined";if(i)t=this.offset;if(!this.noAssert){if(typeof e!=="string")throw TypeError("Illegal str: Not a string");if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: "+t+" (not an integer)");t>>>=0;if(t<0||t+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+t+" (+"+0+") <= "+this.buffer.byteLength)}var r=t,n,s;n=l.calculateUTF16asUTF8(a(e),this.noAssert)[1];s=d.calculateVarint32(n);t+=s+n;var f=this.buffer.byteLength;if(t>f)this.resize((f*=2)>t?f:t);t-=s+n;t+=this.writeVarint32(n,t);l.encodeUTF16toUTF8(a(e),function(e){this.view[t++]=e}.bind(this));if(t!==r+n+s)throw RangeError("Illegal range: Truncated data, "+t+" == "+(t+n+s));if(i){this.offset=t;return this}return t-r},f.readVString=function(e){var t=typeof e==="undefined";if(t)e=this.offset;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+1>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+1+") <= "+this.buffer.byteLength)}var i=e;var r=this.readVarint32(e);var n=this.readUTF8String(r["value"],d.METRICS_BYTES,e+=r["length"]);e+=n["length"];if(t){this.offset=e;return n["string"]}else{return{string:n["string"],length:e-i}}},f.append=function(e,t,i){if(typeof t==="number"||typeof t!=="string"){i=t;t=undefined}var r=typeof i==="undefined";if(r)i=this.offset;if(!this.noAssert){if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal offset: "+i+" (not an integer)");i>>>=0;if(i<0||i+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+i+" (+"+0+") <= "+this.buffer.byteLength)}if(!(e instanceof d))e=d.wrap(e,t);var n=e.limit-e.offset;if(n<=0)return this;i+=n;var s=this.buffer.byteLength;if(i>s)this.resize((s*=2)>i?s:i);i-=n;this.view.set(e.view.subarray(e.offset,e.limit),i);e.offset+=n;if(r)this.offset+=n;return this},f.appendTo=function(e,t){e.append(this,t);return this},f.assert=function(e){this.noAssert=!e;return this},f.capacity=function(){return this.buffer.byteLength},f.clear=function(){this.offset=0;this.limit=this.buffer.byteLength;this.markedOffset=-1;return this},f.clone=function(e){var t=new d(0,this.littleEndian,this.noAssert);if(e){t.buffer=new ArrayBuffer(this.buffer.byteLength);t.view=new Uint8Array(t.buffer)}else{t.buffer=this.buffer;t.view=this.view}t.offset=this.offset;t.markedOffset=this.markedOffset;t.limit=this.limit;return t},f.compact=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal begin: Not an integer");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal end: Not an integer");t>>>=0;if(e<0||e>t||t>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+e+" <= "+t+" <= "+this.buffer.byteLength)}if(e===0&&t===this.buffer.byteLength)return this;var i=t-e;if(i===0){this.buffer=s;this.view=null;if(this.markedOffset>=0)this.markedOffset-=e;this.offset=0;this.limit=0;return this}var r=new ArrayBuffer(i);var n=new Uint8Array(r);n.set(this.view.subarray(e,t));this.buffer=r;this.view=n;if(this.markedOffset>=0)this.markedOffset-=e;this.offset=0;this.limit=i;return this},f.copy=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal begin: Not an integer");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal end: Not an integer");t>>>=0;if(e<0||e>t||t>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+e+" <= "+t+" <= "+this.buffer.byteLength)}if(e===t)return new d(0,this.littleEndian,this.noAssert);var i=t-e,r=new d(i,this.littleEndian,this.noAssert);r.offset=0;r.limit=i;if(r.markedOffset>=0)r.markedOffset-=e;this.copyTo(r,0,e,t);return r},f.copyTo=function(e,t,i,r){var n,s;if(!this.noAssert){if(!d.isByteBuffer(e))throw TypeError("Illegal target: Not a ByteBuffer")}t=(s=typeof t==="undefined")?e.offset:t|0;i=(n=typeof i==="undefined")?this.offset:i|0;r=typeof r==="undefined"?this.limit:r|0;if(t<0||t>e.buffer.byteLength)throw RangeError("Illegal target range: 0 <= "+t+" <= "+e.buffer.byteLength);if(i<0||r>this.buffer.byteLength)throw RangeError("Illegal source range: 0 <= "+i+" <= "+this.buffer.byteLength);var f=r-i;if(f===0)return e;e.ensureCapacity(t+f);e.view.set(this.view.subarray(i,r),t);if(n)this.offset+=f;if(s)e.offset+=f;return this},f.ensureCapacity=function(e){var t=this.buffer.byteLength;if(t<e)return this.resize((t*=2)>e?t:e);return this},f.fill=function(e,t,i){var r=typeof t==="undefined";if(r)t=this.offset;if(typeof e==="string"&&e.length>0)e=e.charCodeAt(0);if(typeof t==="undefined")t=this.offset;if(typeof i==="undefined")i=this.limit;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal value: "+e+" (not an integer)");e|=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal begin: Not an integer");t>>>=0;if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal end: Not an integer");i>>>=0;if(t<0||t>i||i>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+t+" <= "+i+" <= "+this.buffer.byteLength)}if(t>=i)return this;while(t<i)this.view[t++]=e;if(r)this.offset=t;return this},f.flip=function(){this.limit=this.offset;this.offset=0;return this},f.mark=function(e){e=typeof e==="undefined"?this.offset:e;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal offset: "+e+" (not an integer)");e>>>=0;if(e<0||e+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+e+" (+"+0+") <= "+this.buffer.byteLength)}this.markedOffset=e;return this},f.order=function(e){if(!this.noAssert){if(typeof e!=="boolean")throw TypeError("Illegal littleEndian: Not a boolean")}this.littleEndian=!!e;return this},f.LE=function(e){this.littleEndian=typeof e!=="undefined"?!!e:true;return this},f.BE=function(e){this.littleEndian=typeof e!=="undefined"?!e:false;return this},f.prepend=function(e,t,i){if(typeof t==="number"||typeof t!=="string"){i=t;t=undefined}var r=typeof i==="undefined";if(r)i=this.offset;if(!this.noAssert){if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal offset: "+i+" (not an integer)");i>>>=0;if(i<0||i+0>this.buffer.byteLength)throw RangeError("Illegal offset: 0 <= "+i+" (+"+0+") <= "+this.buffer.byteLength)}if(!(e instanceof d))e=d.wrap(e,t);var n=e.limit-e.offset;if(n<=0)return this;var s=n-i;if(s>0){var f=new ArrayBuffer(this.buffer.byteLength+s);var a=new Uint8Array(f);a.set(this.view.subarray(i,this.buffer.byteLength),n);this.buffer=f;this.view=a;this.offset+=s;if(this.markedOffset>=0)this.markedOffset+=s;this.limit+=s;i+=s}else{var o=new Uint8Array(this.buffer)}this.view.set(e.view.subarray(e.offset,e.limit),i-n);e.offset=e.limit;if(r)this.offset-=n;return this},f.prependTo=function(e,t){e.prepend(this,t);return this},f.printDebug=function(e){if(typeof e!=="function")e=console.log.bind(console);e(this.toString()+"\n"+"-------------------------------------------------------------------\n"+this.toDebug(true))},f.remaining=function(){return this.limit-this.offset},f.reset=function(){if(this.markedOffset>=0){this.offset=this.markedOffset;this.markedOffset=-1}else{this.offset=0}return this},f.resize=function(e){if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal capacity: "+e+" (not an integer)");e|=0;if(e<0)throw RangeError("Illegal capacity: 0 <= "+e)}if(this.buffer.byteLength<e){var t=new ArrayBuffer(e);var i=new Uint8Array(t);i.set(this.view);this.buffer=t;this.view=i}return this},f.reverse=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal begin: Not an integer");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal end: Not an integer");t>>>=0;if(e<0||e>t||t>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+e+" <= "+t+" <= "+this.buffer.byteLength)}if(e===t)return this;Array.prototype.reverse.call(this.view.subarray(e,t));return this},f.skip=function(e){if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal length: "+e+" (not an integer)");e|=0}var t=this.offset+e;if(!this.noAssert){if(t<0||t>this.buffer.byteLength)throw RangeError("Illegal length: 0 <= "+this.offset+" + "+e+" <= "+this.buffer.byteLength)}this.offset=t;return this},f.slice=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal begin: Not an integer");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal end: Not an integer");t>>>=0;if(e<0||e>t||t>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+e+" <= "+t+" <= "+this.buffer.byteLength)}var i=this.clone();i.offset=e;i.limit=t;return i},f.toBuffer=function(e){var t=this.offset,i=this.limit;if(!this.noAssert){if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal offset: Not an integer");t>>>=0;if(typeof i!=="number"||i%1!==0)throw TypeError("Illegal limit: Not an integer");i>>>=0;if(t<0||t>i||i>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+t+" <= "+i+" <= "+this.buffer.byteLength)}if(!e&&t===0&&i===this.buffer.byteLength)return this.buffer;if(t===i)return s;var r=new ArrayBuffer(i-t);new Uint8Array(r).set(new Uint8Array(this.buffer).subarray(t,i),0);return r},f.toArrayBuffer=f.toBuffer,f.toString=function(e,t,i){if(typeof e==="undefined")return"ByteBufferAB(offset="+this.offset+",markedOffset="+this.markedOffset+",limit="+this.limit+",capacity="+this.capacity()+")";if(typeof e==="number")e="utf8",t=e,i=t;switch(e){case"utf8":return this.toUTF8(t,i);case"base64":return this.toBase64(t,i);case"hex":return this.toHex(t,i);case"binary":return this.toBinary(t,i);case"debug":return this.toDebug();case"columns":return this.toColumns();default:throw Error("Unsupported encoding: "+e)}};var h=function(){"use strict";var e={};var n=[65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,48,49,50,51,52,53,54,55,56,57,43,47];var f=[];for(var t=0,i=n.length;t<i;++t)f[n[t]]=t;e.encode=function(e,t){var i,r;while((i=e())!==null){t(n[i>>2&63]);r=(i&3)<<4;if((i=e())!==null){r|=i>>4&15;t(n[(r|i>>4&15)&63]);r=(i&15)<<2;if((i=e())!==null)t(n[(r|i>>6&3)&63]),t(n[i&63]);else t(n[r&63]),t(61)}else t(n[r&63]),t(61),t(61)}};e.decode=function(e,t){var i,r,n;function s(e){throw Error("Illegal character code: "+e)}while((i=e())!==null){r=f[i];if(typeof r==="undefined")s(i);if((i=e())!==null){n=f[i];if(typeof n==="undefined")s(i);t(r<<2>>>0|(n&48)>>4);if((i=e())!==null){r=f[i];if(typeof r==="undefined")if(i===61)break;else s(i);t((n&15)<<4>>>0|(r&60)>>2);if((i=e())!==null){n=f[i];if(typeof n==="undefined")if(i===61)break;else s(i);t((r&3)<<6>>>0|n)}}}}};e.test=function(e){return/^(?:[A-Za-z0-9+/]{4})*(?:[A-Za-z0-9+/]{2}==|[A-Za-z0-9+/]{3}=)?$/.test(e)};return e}();f.toBase64=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;e=e|0;t=t|0;if(e<0||t>this.capacity||e>t)throw RangeError("begin, end");var i;h.encode(function(){return e<t?this.view[e++]:null}.bind(this),i=u());return i()},d.fromBase64=function(e,t){if(typeof e!=="string")throw TypeError("str");var i=new d(e.length/4*3,t),r=0;h.decode(a(e),function(e){i.view[r++]=e});i.limit=r;return i},d.btoa=function(e){return d.fromBinary(e).toBase64()},d.atob=function(e){return d.fromBase64(e).toBinary()},f.toBinary=function(e,t){if(typeof e==="undefined")e=this.offset;if(typeof t==="undefined")t=this.limit;e|=0;t|=0;if(e<0||t>this.capacity()||e>t)throw RangeError("begin, end");if(e===t)return"";var i=[],r=[];while(e<t){i.push(this.view[e++]);if(i.length>=1024)r.push(String.fromCharCode.apply(String,i)),i=[]}return r.join("")+String.fromCharCode.apply(String,i)},d.fromBinary=function(e,t){if(typeof e!=="string")throw TypeError("str");var i=0,r=e.length,n,s=new d(r,t);while(i<r){n=e.charCodeAt(i);if(n>255)throw RangeError("illegal char code: "+n);s.view[i++]=n}s.limit=r;return s},f.toDebug=function(e){var t=-1,i=this.buffer.byteLength,r,n="",s="",f="";while(t<i){if(t!==-1){r=this.view[t];if(r<16)n+="0"+r.toString(16).toUpperCase();else n+=r.toString(16).toUpperCase();if(e)s+=r>32&&r<127?String.fromCharCode(r):"."}++t;if(e){if(t>0&&t%16===0&&t!==i){while(n.length<3*16+3)n+=" ";f+=n+s+"\n";n=s=""}}if(t===this.offset&&t===this.limit)n+=t===this.markedOffset?"!":"|";else if(t===this.offset)n+=t===this.markedOffset?"[":"<";else if(t===this.limit)n+=t===this.markedOffset?"]":">";else n+=t===this.markedOffset?"'":e||t!==0&&t!==i?" ":""}if(e&&n!==" "){while(n.length<3*16+3)n+=" ";f+=n+s+"\n"}return e?f:n},d.fromDebug=function(e,t,i){var r=e.length,n=new d((r+1)/3|0,t,i);var s=0,f=0,a,o,u=false,h=false,l=false,b=false,c=false;while(s<r){switch(a=e.charAt(s++)){case"!":if(!i){if(h||l||b){c=true;break}h=l=b=true}n.offset=n.markedOffset=n.limit=f;u=false;break;case"|":if(!i){if(h||b){c=true;break}h=b=true}n.offset=n.limit=f;u=false;break;case"[":if(!i){if(h||l){c=true;break}h=l=true}n.offset=n.markedOffset=f;u=false;break;case"<":if(!i){if(h){c=true;break}h=true}n.offset=f;u=false;break;case"]":if(!i){if(b||l){c=true;break}b=l=true}n.limit=n.markedOffset=f;u=false;break;case">":if(!i){if(b){c=true;break}b=true}n.limit=f;u=false;break;case"'":if(!i){if(l){c=true;break}l=true}n.markedOffset=f;u=false;break;case" ":u=false;break;default:if(!i){if(u){c=true;break}}o=parseInt(a+e.charAt(s++),16);if(!i){if(isNaN(o)||o<0||o>255)throw TypeError("Illegal str: Not a debug encoded string")}n.view[f++]=o;u=true}if(c)throw TypeError("Illegal str: Invalid symbol at "+s)}if(!i){if(!h||!b)throw TypeError("Illegal str: Missing offset or limit");if(f<n.buffer.byteLength)throw TypeError("Illegal str: Not a debug encoded string (is it hex?) "+f+" < "+r)}return n},f.toHex=function(e,t){e=typeof e==="undefined"?this.offset:e;t=typeof t==="undefined"?this.limit:t;if(!this.noAssert){if(typeof e!=="number"||e%1!==0)throw TypeError("Illegal begin: Not an integer");e>>>=0;if(typeof t!=="number"||t%1!==0)throw TypeError("Illegal end: Not an integer");t>>>=0;if(e<0||e>t||t>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+e+" <= "+t+" <= "+this.buffer.byteLength)}var i=new Array(t-e),r;while(e<t){r=this.view[e++];if(r<16)i.push("0",r.toString(16));else i.push(r.toString(16))}return i.join("")},d.fromHex=function(e,t,i){if(!i){if(typeof e!=="string")throw TypeError("Illegal str: Not a string");if(e.length%2!==0)throw TypeError("Illegal str: Length not a multiple of 2")}var r=e.length,n=new d(r/2|0,t),s;for(var f=0,a=0;f<r;f+=2){s=parseInt(e.substring(f,f+2),16);if(!i)if(!isFinite(s)||s<0||s>255)throw TypeError("Illegal str: Contains non-hex characters");n.view[a++]=s}n.limit=a;return n};var l=function(){"use strict";var r={};r.MAX_CODEPOINT=1114111;r.encodeUTF8=function(e,t){var i=null;if(typeof e==="number")i=e,e=function(){return null};while(i!==null||(i=e())!==null){if(i<128)t(i&127);else if(i<2048)t(i>>6&31|192),t(i&63|128);else if(i<65536)t(i>>12&15|224),t(i>>6&63|128),t(i&63|128);else t(i>>18&7|240),t(i>>12&63|128),t(i>>6&63|128),t(i&63|128);i=null}};r.decodeUTF8=function(e,t){var i,r,n,s,f=function(e){e=e.slice(0,e.indexOf(null));var t=Error(e.toString());t.name="TruncatedError";t["bytes"]=e;throw t};while((i=e())!==null){if((i&128)===0)t(i);else if((i&224)===192)(r=e())===null&&f([i,r]),t((i&31)<<6|r&63);else if((i&240)===224)((r=e())===null||(n=e())===null)&&f([i,r,n]),t((i&15)<<12|(r&63)<<6|n&63);else if((i&248)===240)((r=e())===null||(n=e())===null||(s=e())===null)&&f([i,r,n,s]),t((i&7)<<18|(r&63)<<12|(n&63)<<6|s&63);else throw RangeError("Illegal starting byte: "+i)}};r.UTF16toUTF8=function(e,t){var i,r=null;while(true){if((i=r!==null?r:e())===null)break;if(i>=55296&&i<=57343){if((r=e())!==null){if(r>=56320&&r<=57343){t((i-55296)*1024+r-56320+65536);r=null;continue}}}t(i)}if(r!==null)t(r)};r.UTF8toUTF16=function(e,t){var i=null;if(typeof e==="number")i=e,e=function(){return null};while(i!==null||(i=e())!==null){if(i<=65535)t(i);else i-=65536,t((i>>10)+55296),t(i%1024+56320);i=null}};r.encodeUTF16toUTF8=function(e,t){r.UTF16toUTF8(e,function(e){r.encodeUTF8(e,t)})};r.decodeUTF8toUTF16=function(e,t){r.decodeUTF8(e,function(e){r.UTF8toUTF16(e,t)})};r.calculateCodePoint=function(e){return e<128?1:e<2048?2:e<65536?3:4};r.calculateUTF8=function(e){var t,i=0;while((t=e())!==null)i+=t<128?1:t<2048?2:t<65536?3:4;return i};r.calculateUTF16asUTF8=function(e){var t=0,i=0;r.UTF16toUTF8(e,function(e){++t;i+=e<128?1:e<2048?2:e<65536?3:4});return[t,i]};return r}();return f.toUTF8=function(t,i){if(void 0===t&&(t=this.offset),void 0===i&&(i=this.limit),!this.noAssert){if("number"!=typeof t||t%1!=0)throw TypeError("Illegal begin: Not an integer");if(t>>>=0,"number"!=typeof i||i%1!=0)throw TypeError("Illegal end: Not an integer");if(i>>>=0,t<0||i<t||i>this.buffer.byteLength)throw RangeError("Illegal range: 0 <= "+t+" <= "+i+" <= "+this.buffer.byteLength)}var e;try{l.decodeUTF8toUTF16(function(){return t<i?this.view[t++]:null}.bind(this),e=u())}catch(e){if(t!==i)throw RangeError("Illegal range: Truncated data, "+t+" != "+i)}return e()},d.fromUTF8=function(e,t,i){if(!i&&"string"!=typeof e)throw TypeError("Illegal str: Not a string");var r=new d(l.calculateUTF16asUTF8(a(e),!0)[1],t,i),n=0;return l.encodeUTF16toUTF8(a(e),function(e){r.view[n++]=e}),r.limit=n,r},d})?r.apply(t,n):r)||(e.exports=s)},function(e,t,i){var r,n,s;n=[],void 0===(s="function"==typeof(r=function(){"use strict";function r(e,t,i){this.low=e|0;this.high=t|0;this.unsigned=!!i}function c(e){return(e&&e["__isLong__"])===true}r.prototype.__isLong__,Object.defineProperty(r.prototype,"__isLong__",{value:true,enumerable:false,configurable:false}),r.isLong=c;var s={},f={};function e(e,t){var i,r,n;if(t){e>>>=0;if(n=0<=e&&e<256){r=f[e];if(r)return r}i=_(e,(e|0)<0?-1:0,true);if(n)f[e]=i;return i}else{e|=0;if(n=-128<=e&&e<128){r=s[e];if(r)return r}i=_(e,e<0?-1:0,false);if(n)s[e]=i;return i}}function d(e,t){if(isNaN(e)||!isFinite(e))return t?u:p;if(t){if(e<0)return u;if(e>=a)return U}else{if(e<=-o)return E;if(e+1>=o)return m}if(e<0)return d(-e,t).neg();return _(e%n|0,e/n|0,t)}function _(e,t,i){return new r(e,t,i)}r.fromInt=e,r.fromNumber=d,r.fromBits=_;var h=Math.pow;function l(e,t,i){if(e.length===0)throw Error("empty string");if(e==="NaN"||e==="Infinity"||e==="+Infinity"||e==="-Infinity")return p;if(typeof t==="number"){i=t,t=false}else{t=!!t}i=i||10;if(i<2||36<i)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");else if(r===0){return l(e.substring(1),t,i).neg()}var n=d(h(i,8));var s=p;for(var f=0;f<e.length;f+=8){var a=Math.min(8,e.length-f),o=parseInt(e.substring(f,f+a),i);if(a<8){var u=d(h(i,a));s=s.mul(u).add(d(o))}else{s=s.mul(n);s=s.add(d(o))}}s.unsigned=t;return s}function g(e){if(e instanceof r)return e;if(typeof e==="number")return d(e);if(typeof e==="string")return l(e);return _(e.low,e.high,e.unsigned)}r.fromString=l,r.fromValue=g;var t=1<<16,i,n=t*t,a=n*n,o=a/2,w=e(1<<24),p=e(0);r.ZERO=p;var u=e(0,true);r.UZERO=u;var b=e(1);r.ONE=b;var y=e(1,true);r.UONE=y;var v=e(-1);r.NEG_ONE=v;var m=_(4294967295|0,2147483647|0,false);r.MAX_VALUE=m;var U=_(4294967295|0,4294967295|0,true);r.MAX_UNSIGNED_VALUE=U;var E=_(0,2147483648|0,false);r.MIN_VALUE=E;var T=r.prototype;return T.toInt=function(){return this.unsigned?this.low>>>0:this.low},T.toNumber=function(){return this.unsigned?(this.high>>>0)*n+(this.low>>>0):this.high*n+(this.low>>>0)},T.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(E)){var t=d(e),i=this.div(t),r=i.mul(t).sub(this);return i.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var n=d(h(e,6),this.unsigned),s=this,f="";;){var a=s.div(n),o=(s.sub(a.mul(n)).toInt()>>>0).toString(e);if((s=a).isZero())return o+f;for(;o.length<6;)o="0"+o;f=""+o+f}},T.getHighBits=function(){return this.high},T.getHighBitsUnsigned=function(){return this.high>>>0},T.getLowBits=function(){return this.low},T.getLowBitsUnsigned=function(){return this.low>>>0},T.getNumBitsAbs=function(){if(this.isNegative())return this.eq(E)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;0<t&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},T.isZero=function(){return 0===this.high&&0===this.low},T.isNegative=function(){return!this.unsigned&&this.high<0},T.isPositive=function(){return this.unsigned||0<=this.high},T.isOdd=function(){return 1==(1&this.low)},T.isEven=function(){return 0==(1&this.low)},T.equals=function(e){return c(e)||(e=g(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},T.eq=T.equals,T.notEquals=function(e){return!this.eq(e)},T.neq=T.notEquals,T.lessThan=function(e){return this.comp(e)<0},T.lt=T.lessThan,T.lessThanOrEqual=function(e){return this.comp(e)<=0},T.lte=T.lessThanOrEqual,T.greaterThan=function(e){return 0<this.comp(e)},T.gt=T.greaterThan,T.greaterThanOrEqual=function(e){return 0<=this.comp(e)},T.gte=T.greaterThanOrEqual,T.compare=function(e){if(c(e)||(e=g(e)),this.eq(e))return 0;var t=this.isNegative(),i=e.isNegative();return t&&!i?-1:!t&&i?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},T.comp=T.compare,T.negate=function(){return!this.unsigned&&this.eq(E)?E:this.not().add(b)},T.neg=T.negate,T.add=function(e){c(e)||(e=g(e));var t=this.high>>>16,i=65535&this.high,r=this.low>>>16,n=65535&this.low,s=e.high>>>16,f=65535&e.high,a=e.low>>>16,o=0,u=0,h=0,l=0;return h+=(l+=n+(65535&e.low))>>>16,u+=(h+=r+a)>>>16,o+=(u+=i+f)>>>16,o+=t+s,_((h&=65535)<<16|(l&=65535),(o&=65535)<<16|(u&=65535),this.unsigned)},T.subtract=function(e){return c(e)||(e=g(e)),this.add(e.neg())},T.sub=T.subtract,T.multiply=function(e){if(this.isZero())return p;if(c(e)||(e=g(e)),e.isZero())return p;if(this.eq(E))return e.isOdd()?E:p;if(e.eq(E))return this.isOdd()?E:p;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(w)&&e.lt(w))return d(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,i=65535&this.high,r=this.low>>>16,n=65535&this.low,s=e.high>>>16,f=65535&e.high,a=e.low>>>16,o=65535&e.low,u=0,h=0,l=0,b=0;return l+=(b+=n*o)>>>16,h+=(l+=r*o)>>>16,l&=65535,h+=(l+=n*a)>>>16,u+=(h+=i*o)>>>16,h&=65535,u+=(h+=r*a)>>>16,h&=65535,u+=(h+=n*f)>>>16,u+=t*o+i*a+r*f+n*s,_((l&=65535)<<16|(b&=65535),(u&=65535)<<16|(h&=65535),this.unsigned)},T.mul=T.multiply,T.divide=function(e){if(c(e)||(e=g(e)),e.isZero())throw Error("division by zero");if(this.isZero())return this.unsigned?u:p;var t,i,r;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return u;if(e.gt(this.shru(1)))return y;r=u}else{if(this.eq(E))return e.eq(b)||e.eq(v)?E:e.eq(E)?b:(t=this.shr(1).div(e).shl(1)).eq(p)?e.isNegative()?b:v:(i=this.sub(e.mul(t)),r=t.add(i.div(e)));else if(e.eq(E))return this.unsigned?u:p;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=p}for(i=this;i.gte(e);){t=Math.max(1,Math.floor(i.toNumber()/e.toNumber()));for(var n=Math.ceil(Math.log(t)/Math.LN2),s=n<=48?1:h(2,n-48),f=d(t),a=f.mul(e);a.isNegative()||a.gt(i);)a=(f=d(t-=s,this.unsigned)).mul(e);f.isZero()&&(f=b),r=r.add(f),i=i.sub(a)}return r},T.div=T.divide,T.modulo=function(e){return c(e)||(e=g(e)),this.sub(this.div(e).mul(e))},T.mod=T.modulo,T.not=function(){return _(~this.low,~this.high,this.unsigned)},T.and=function(e){return c(e)||(e=g(e)),_(this.low&e.low,this.high&e.high,this.unsigned)},T.or=function(e){return c(e)||(e=g(e)),_(this.low|e.low,this.high|e.high,this.unsigned)},T.xor=function(e){return c(e)||(e=g(e)),_(this.low^e.low,this.high^e.high,this.unsigned)},T.shiftLeft=function(e){return c(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?_(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):_(0,this.low<<e-32,this.unsigned)},T.shl=T.shiftLeft,T.shiftRight=function(e){return c(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?_(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):_(this.high>>e-32,0<=this.high?0:-1,this.unsigned)},T.shr=T.shiftRight,T.shiftRightUnsigned=function(e){if(c(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?_(this.low>>>e|t<<32-e,t>>>e,this.unsigned):_(32===e?t:t>>>e-32,0,this.unsigned)},T.shru=T.shiftRightUnsigned,T.toSigned=function(){return this.unsigned?_(this.low,this.high,!1):this},T.toUnsigned=function(){return this.unsigned?this:_(this.low,this.high,!0)},T.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},T.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24&255,255&e,e>>>8&255,e>>>16&255,e>>>24&255]},T.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24&255,e>>>16&255,e>>>8&255,255&e,t>>>24&255,t>>>16&255,t>>>8&255,255&t]},r})?r.apply(t,n):r)||(e.exports=s)},function(e,t,i){"use strict";i.r(t);t.default={UTF8:1,INTEGER:3,FLOAT:4,LONG:5,DOUBLE:6,CLASS:7,STRING:8,FIELDREF:9,METHODREF:10,INTERFACE_METHODREF:11,NAME_AND_TYPE:12,METHOD_HANDLE:15,METHOD_TYPE:16,DYNAMIC:17,INVOKE_DYNAMIC:18,MODULE:19,PACKAGE:20}},function(e,t){},function(e,t,i){"use strict";i.r(t);var r=i(3),n=i.n(r),s=i(5);function f(e,t){for(var i=0;i<t.length;i++){var r=t[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,i){t&&f(e.prototype,t),i&&f(e,i)}(e,[{key:"write",value:function(e){return this.buf=new n.a,this.classFile=e,this.buf.writeUint8(202),this.buf.writeUint8(254),this.buf.writeUint8(186),this.buf.writeUint8(190),this.buf.writeUint16(e.minor_version),this.buf.writeUint16(e.major_version),this.buf.writeUint16(e.constant_pool_count),this._writeConstantPool(e.constant_pool),this.buf.writeUint16(e.access_flags),this.buf.writeUint16(e.this_class),this.buf.writeUint16(e.super_class),this.buf.writeUint16(e.interfaces_count),this._writeInterfaces(e.interfaces),this.buf.writeUint16(e.fields_count),this._writeMemberInfoArray(e.fields),this.buf.writeUint16(e.methods_count),this._writeMemberInfoArray(e.methods),this.buf.writeUint16(e.attributes_count),this._writeAttributeInfoArray(e.attributes),this.buf.buffer=this.buf.buffer.slice(0,this.buf.offset),this.buf}},{key:"_writeMemberInfoArray",value:function(e){for(var t=0;t<e.length;t++){var i=e[t];this.buf.writeUint16(i.access_flags),this.buf.writeUint16(i.name_index),this.buf.writeUint16(i.descriptor_index),this.buf.writeUint16(i.attributes_count),this._writeAttributeInfoArray(i.attributes)}}},{key:"_writeAttributeInfoArray",value:function(e){for(var t=0;t<e.length;t++)this._writeAttributeInfo(e[t])}},{key:"_writeAttributeAnnotation",value:function(e){this.buf.writeUint16(e.type_index),this.buf.writeUint16(e.num_element_value_pairs);for(var t=0;t<e.num_element_value_pairs;t++){var i=e.element_value_pairs[t];this.buf.writeUint16(i.element_name_index),this._writeElementValue(i.element_value)}}},{key:"_writeElementValue",value:function(e){this.buf.writeUint8(e.tag);var t=e.value;switch(e.tag){case 101:this.buf.writeUint16(t.enum_const_value.type_name_index),this.buf.writeUint16(t.enum_const_value.const_name_index);break;case 99:this.buf.writeUint16(t.class_info_index);break;case 91:this.buf.writeUint16(t.array_value.num_values);for(var i=0;i<t.array_value.num_values;i++)this._writeElementValue(t.array_value.values[i]);break;case 64:this._writeAttributeAnnotation(t.annotation);break;case 66:case 67:case 68:case 70:case 73:case 74:case 83:case 90:case 115:this.buf.writeUint16(t.const_value_index);break;default:throw Error("Unexpected tag: ".concat(e.tag))}}},{key:"_writeTypeAnnotation",value:function(e){switch(this.buf.writeUint8(e.target_type),e.target_type){case 0:case 1:this.buf.writeUint8(e.target_info.type_parameter_index);break;case 16:this.buf.writeUint16(e.target_info.supertype_index);break;case 17:case 18:this.buf.writeUint8(e.target_info.type_parameter_index),this.buf.writeUint8(e.target_info.bound_index);break;case 19:case 20:case 21:break;case 22:this.buf.writeUint8(e.target_info.formal_parameter_index);break;case 23:this.buf.writeUint16(e.target_info.throws_type_index);break;case 64:case 65:this.buf.writeUint16(e.target_info.table_length);for(var t=0;t<e.target_info.table_length;t++){var i=e.target_info.table[t];this.buf.writeUint16(i.start_pc),this.buf.writeUint16(i.length),this.buf.writeUint16(i.index)}break;case 66:this.buf.writeUint16(e.target_info.exception_table_index);break;case 67:case 68:case 69:case 70:this.buf.writeUint16(e.target_info.offset);break;case 71:case 72:case 73:case 74:case 75:this.buf.writeUint16(e.target_info.offset),this.buf.writeUint8(e.target_info.type_argument_index);break;default:throw Error("Unexpected target_type: ".concat(e.target_type))}this.buf.writeUint8(e.type_path.path_length);for(t=0;t<e.type_path.path_length;t++){var r=e.type_path.path[t];this.buf.writeUint8(r.type_path_kind),this.buf.writeUint8(r.type_argument_index)}this.buf.writeUint16(e.type_index),this.buf.writeUint16(e.num_element_value_pairs);for(t=0;t<e.num_element_value_pairs;t++){var n=e.element_value_pairs[t];this.buf.writeUint16(n.element_name_index),this._writeElementValue(n.element_value)}}},{key:"_writeAttributeInfo",value:function(e){this.buf.writeUint16(e.attribute_name_index),this.buf.writeUint32(e.attribute_length);var t=this.classFile.constant_pool[e.attribute_name_index].bytes;switch(String.fromCharCode.apply(null,t)){case"RuntimeInvisibleAnnotations":case"RuntimeVisibleAnnotations":this.buf.writeUint16(e.num_annotations);for(var i=0;i<e.num_annotations;i++)this._writeAttributeAnnotation(e.annotations[i]);break;case"Deprecated":case"Synthetic":break;case"InnerClasses":this.buf.writeUint16(e.number_of_classes);for(i=0;i<e.number_of_classes;i++){var r=e.classes[i];this.buf.writeUint16(r.inner_class_info_index),this.buf.writeUint16(r.outer_class_info_index),this.buf.writeUint16(r.inner_name_index),this.buf.writeUint16(r.inner_class_access_flags)}break;case"LocalVariableTable":this.buf.writeUint16(e.local_variable_table_length);for(i=0;i<e.local_variable_table_length;i++){var n=e.local_variable_table[i];this.buf.writeUint16(n.start_pc),this.buf.writeUint16(n.length),this.buf.writeUint16(n.name_index),this.buf.writeUint16(n.descriptor_index),this.buf.writeUint16(n.index)}break;case"LocalVariableTypeTable":this.buf.writeUint16(e.local_variable_type_table_length);for(i=0;i<e.local_variable_type_table_length;i++){var s=e.local_variable_type_table[i];this.buf.writeUint16(s.start_pc),this.buf.writeUint16(s.length),this.buf.writeUint16(s.name_index),this.buf.writeUint16(s.signature_index),this.buf.writeUint16(s.index)}break;case"RuntimeInvisibleParameterAnnotations":case"RuntimeVisibleParameterAnnotations":this.buf.writeUint8(e.num_parameters);for(i=0;i<e.num_parameters;i++){var f=e.parameter_annotations[i];this.buf.writeUint16(f.num_annotations);for(var a=0;a<f.num_annotations;a++)this._writeAttributeAnnotation(f.annotations[a])}break;case"BootstrapMethods":this.buf.writeUint16(e.num_bootstrap_methods);for(i=0;i<e.num_bootstrap_methods;i++){var o=e.bootstrap_methods[i];this.buf.writeUint16(o.bootstrap_method_ref),this.buf.writeUint16(o.num_bootstrap_arguments);for(a=0;a<o.num_bootstrap_arguments;a++)this.buf.writeUint16(o.bootstrap_arguments[a])}break;case"RuntimeInvisibleTypeAnnotations":case"RuntimeVisibleTypeAnnotations":this.buf.writeUint16(e.num_annotations);for(i=0;i<e.num_annotations;i++)this._writeTypeAnnotation(e.annotations[i]);break;case"SourceDebugExtension":for(i=0;i<e.attribute_length;i++)this.buf.writeUint8(e.debug_extension[i]);break;case"SourceFile":this.buf.writeUint16(e.sourcefile_index);break;case"EnclosingMethod":this.buf.writeUint16(e.class_index),this.buf.writeUint16(e.method_index);break;case"AnnotationDefault":this._writeElementValue(e.default_value);break;case"MethodParameters":this.buf.writeUint8(e.parameters_count);for(i=0;i<e.parameters_count;i++){var u=e.parameters[i];this.buf.writeUint16(u.name_index),this.buf.writeUint16(u.access_flags)}break;case"Exceptions":this.buf.writeUint16(e.number_of_exceptions);for(i=0;i<e.number_of_exceptions;i++)this.buf.writeUint16(e.exception_index_table[i]);break;case"ConstantValue":this.buf.writeUint16(e.constantvalue_index);break;case"Signature":this.buf.writeUint16(e.signature_index);break;case"StackMapTable":this.buf.writeUint16(e.number_of_entries);for(i=0;i<e.number_of_entries;i++){var h=e.entries[i],l=h.frame_type;if(this.buf.writeUint8(l),64<=l&&l<=127)this._writeVerificationTypeInfo(h.stack[0]);else if(247===h.frame_type)this.buf.writeUint16(h.offset_delta),this._writeVerificationTypeInfo(h.stack[0]);else if(248<=l&&l<=251)this.buf.writeUint16(h.offset_delta);else if(252<=l&&l<=254){this.buf.writeUint16(h.offset_delta);var b=l-251;for(a=0;a<b;a++)this._writeVerificationTypeInfo(h.locals[a])}else if(255===l){this.buf.writeUint16(h.offset_delta),this.buf.writeUint16(h.number_of_locals);for(a=0;a<h.number_of_locals;a++)this._writeVerificationTypeInfo(h.locals[a]);this.buf.writeUint16(h.number_of_stack_items);for(a=0;a<h.number_of_stack_items;a++)this._writeVerificationTypeInfo(h.stack[a])}}break;case"Code":this.buf.writeUint16(e.max_stack),this.buf.writeUint16(e.max_locals),this.buf.writeUint32(e.code_length);for(i=0;i<e.code_length;i++)this.buf.writeUint8(e.code[i]);this.buf.writeUint16(e.exception_table_length);for(i=0;i<e.exception_table_length;i++){var c=e.exception_table[i];this.buf.writeUint16(c.start_pc),this.buf.writeUint16(c.end_pc),this.buf.writeUint16(c.handler_pc),this.buf.writeUint16(c.catch_type)}this.buf.writeUint16(e.attributes_count),this._writeAttributeInfoArray(e.attributes);break;case"LineNumberTable":this.buf.writeUint16(e.line_number_table_length);for(i=0;i<e.line_number_table_length;i++){var d=e.line_number_table[i];this.buf.writeUint16(d.start_pc),this.buf.writeUint16(d.line_number)}break;case"Module":this.buf.writeUint16(e.module_name_index),this.buf.writeUint16(e.module_flags),this.buf.writeUint16(e.module_version_index),this.buf.writeUint16(e.requires_count);for(i=0;i<e.requires_count;i++){var _=e.requires[i];this.buf.writeUint16(_.requires_index),this.buf.writeUint16(_.requires_flags),this.buf.writeUint16(_.requires_version_index)}this.buf.writeUint16(e.exports_count);for(i=0;i<e.exports_count;i++){var g=e.exports[i];this.buf.writeUint16(g.exports_index),this.buf.writeUint16(g.exports_flags),this.buf.writeUint16(g.exports_to_count);for(a=0;a<g.exports_to_count;a++)this.buf.writeUint16(g.exports_to_index[a])}this.buf.writeUint16(e.opens_count);for(i=0;i<e.opens_count;i++){var w=e.opens[i];this.buf.writeUint16(w.opens_index),this.buf.writeUint16(w.opens_flags),this.buf.writeUint16(w.opens_to_count);for(a=0;a<w.opens_to_count;a++)this.buf.writeUint16(w.opens_to_index[a])}this.buf.writeUint16(e.uses_count);for(i=0;i<e.uses_count;i++)this.buf.writeUint16(e.uses_index[i]);this.buf.writeUint16(e.provides_count);for(i=0;i<e.provides_count;i++){var p=e.provides[i];this.buf.writeUint16(p.provides_index),this.buf.writeUint16(p.provides_with_count);for(a=0;a<p.provides_with_count;a++)this.buf.writeUint16(p.provides_with_index[a])}break;case"ModulePackages":this.buf.writeUint16(e.package_count);for(i=0;i<e.package_count;i++)this.buf.writeUint16(e.package_index[i]);break;case"ModuleMainClass":this.buf.writeUint16(e.main_class_index);break;case"NestHost":this.buf.writeUint16(e.host_class_index);break;case"NestMembers":this.buf.writeUint16(e.number_of_classes);for(var y=0;y<e.number_of_classes;y++)this.buf.writeUint16(e.classes[y]);break;default:for(i=0;i<e.attribute_length;i++)this.buf.writeUint8(e.info[i])}}},{key:"_writeVerificationTypeInfo",value:function(e){this.buf.writeUint8(e.tag),7===e.tag?this.buf.writeUint16(e.cpool_index):8===e.tag&&this.buf.writeUint16(e.offset)}},{key:"_writeInterfaces",value:function(e){for(var t=0;t<e.length;t++)this.buf.writeUint16(e[t])}},{key:"_writeConstantPool",value:function(e){for(var t=1;t<e.length;t++){var i=e[t];void 0!==i&&this._writeConstantPoolEntry(i)}}},{key:"_writeConstantPoolEntry",value:function(e){switch(this.buf.writeUint8(e.tag),e.tag){case s.default.UTF8:this.buf.writeUint16(e.length);for(var t=0;t<e.length;t++)this.buf.writeUint8(e.bytes[t]);break;case s.default.INTEGER:case s.default.FLOAT:this.buf.writeUint32(e.bytes);break;case s.default.LONG:case s.default.DOUBLE:this.buf.writeUint32(e.high_bytes),this.buf.writeUint32(e.low_bytes);break;case s.default.PACKAGE:case s.default.MODULE:case s.default.CLASS:this.buf.writeUint16(e.name_index);break;case s.default.STRING:this.buf.writeUint16(e.string_index);break;case s.default.FIELDREF:case s.default.METHODREF:case s.default.INTERFACE_METHODREF:this.buf.writeUint16(e.class_index),this.buf.writeUint16(e.name_and_type_index);break;case s.default.NAME_AND_TYPE:this.buf.writeUint16(e.name_index),this.buf.writeUint16(e.descriptor_index);break;case s.default.METHOD_HANDLE:this.buf.writeUint8(e.reference_kind),this.buf.writeUint16(e.reference_index);break;case s.default.METHOD_TYPE:this.buf.writeUint16(e.descriptor_index);break;case s.default.DYNAMIC:case s.default.INVOKE_DYNAMIC:this.buf.writeUint16(e.bootstrap_method_attr_index),this.buf.writeUint16(e.name_and_type_index);break;default:throw Error("Unexpected tag: ".concat(e.tag))}}}]),e}();t.default=a},function(e,t,i){"use strict";i.r(t);t.default={NOP:0,ACONST_NULL:1,ICONST_M1:2,ICONST_0:3,ICONST_1:4,ICONST_2:5,ICONST_3:6,ICONST_4:7,ICONST_5:8,LCONST_0:9,LCONST_1:10,FCONST_0:11,FCONST_1:12,FCONST_2:13,DCONST_0:14,DCONST_1:15,BIPUSH:16,SIPUSH:17,LDC:18,LDC_W:19,LDC2_W:20,ILOAD:21,LLOAD:22,FLOAD:23,DLOAD:24,ALOAD:25,ILOAD_0:26,ILOAD_1:27,ILOAD_2:28,ILOAD_3:29,LLOAD_0:30,LLOAD_1:31,LLOAD_2:32,LLOAD_3:33,FLOAD_0:34,FLOAD_1:35,FLOAD_2:36,FLOAD_3:37,DLOAD_0:38,DLOAD_1:39,DLOAD_2:40,DLOAD_3:41,ALOAD_0:42,ALOAD_1:43,ALOAD_2:44,ALOAD_3:45,IALOAD:46,LALOAD:47,FALOAD:48,DALOAD:49,AALOAD:50,BALOAD:51,CALOAD:52,SALOAD:53,ISTORE:54,LSTORE:55,FSTORE:56,DSTORE:57,ASTORE:58,ISTORE_0:59,ISTORE_1:60,ISTORE_2:61,ISTORE_3:62,LSTORE_0:63,LSTORE_1:64,LSTORE_2:65,LSTORE_3:66,FSTORE_0:67,FSTORE_1:68,FSTORE_2:69,FSTORE_3:70,DSTORE_0:71,DSTORE_1:72,DSTORE_2:73,DSTORE_3:74,ASTORE_0:75,ASTORE_1:76,ASTORE_2:77,ASTORE_3:78,IASTORE:79,LASTORE:80,FASTORE:81,DASTORE:82,AASTORE:83,BASTORE:84,CASTORE:85,SASTORE:86,POP:87,POP2:88,DUP:89,DUP_X1:90,DUP_X2:91,DUP2:92,DUP2_X1:93,DUP2_X2:94,SWAP:95,IADD:96,LADD:97,FADD:98,DADD:99,ISUB:100,LSUB:101,FSUB:102,DSUB:103,IMUL:104,LMUL:105,FMUL:106,DMUL:107,IDIV:108,LDIV:109,FDIV:110,DDIV:111,IREM:112,LREM:113,FREM:114,DREM:115,INEG:116,LNEG:117,FNEG:118,DNEG:119,ISHL:120,LSHL:121,ISHR:122,LSHR:123,IUSHR:124,LUSHR:125,IAND:126,LAND:127,IOR:128,LOR:129,IXOR:130,LXOR:131,IINC:132,I2L:133,I2F:134,I2D:135,L2I:136,L2F:137,L2D:138,F2I:139,F2L:140,F2D:141,D2I:142,D2L:143,D2F:144,I2B:145,I2C:146,I2S:147,LCMP:148,FCMPL:149,FCMPG:150,DCMPL:151,DCMPG:152,IFEQ:153,IFNE:154,IFLT:155,IFGE:156,IFGT:157,IFLE:158,IF_ICMPEQ:159,IF_ICMPNE:160,IF_ICMPLT:161,IF_ICMPGE:162,IF_ICMPGT:163,IF_ICMPLE:164,IF_ACMPEQ:165,IF_ACMPNE:166,GOTO:167,JSR:168,RET:169,TABLESWITCH:170,LOOKUPSWITCH:171,IRETURN:172,LRETURN:173,FRETURN:174,DRETURN:175,ARETURN:176,RETURN:177,GETSTATIC:178,PUTSTATIC:179,GETFIELD:180,PUTFIELD:181,INVOKEVIRTUAL:182,INVOKESPECIAL:183,INVOKESTATIC:184,INVOKEINTERFACE:185,INVOKEDYNAMIC:186,NEW:187,NEWARRAY:188,ANEWARRAY:189,ARRAYLENGTH:190,ATHROW:191,CHECKCAST:192,INSTANCEOF:193,MONITORENTER:194,MONITOREXIT:195,WIDE:196,MULTIANEWARRAY:197,IFNULL:198,IFNONNULL:199,GOTO_W:200,JSR_W:201,BREAKPOINT:202,IMPDEP1:254,IMPDEP2:255}},function(e,t,i){"use strict";i.r(t);t.default={PUBLIC:1,PRIVATE:2,PROTECTED:4,STATIC:8,FINAL:16,SYNCHRONIZED:32,VOLATILE:64,BRIDGE:64,TRANSIENT:128,VARARGS:128,NATIVE:256,ABSTRACT:1024,STRICT:2048,SYNTHETIC:4096,INTERFACE:512,SUPER:32,ANNOTATION:8192,ENUM:16384,MODULE:32768}},function(e,t,i){"use strict";i.r(t),i.d(t,"Instruction",function(){return h}),i.d(t,"InstructionParser",function(){return a});var l=i(8);function b(e){return function(e){if(Array.isArray(e)){for(var t=0,i=new Array(e.length);t<e.length;t++)i[t]=e[t];return i}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}function n(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function r(e,t){for(var i=0;i<t.length;i++){var r=t[i];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function s(e,t,i){return t&&r(e.prototype,t),i&&r(e,i),e}var u=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1,2,2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,-1,-1,0,0,0,0,0,0,2,2,2,2,2,2,2,4,4,2,1,2,0,0,2,2,0,0,-1,3,2,2,4,4,0],f=["nop","aconst_null","iconst_m1","iconst_0","iconst_1","iconst_2","iconst_3","iconst_4","iconst_5","lconst_0","lconst_1","fconst_0","fconst_1","fconst_2","dconst_0","dconst_1","bipush","sipush","ldc","ldc_w","ldc2_w","iload","lload","fload","dload","aload","iload_0","iload_1","iload_2","iload_3","lload_0","lload_1","lload_2","lload_3","fload_0","fload_1","fload_2","fload_3","dload_0","dload_1","dload_2","dload_3","aload_0","aload_1","aload_2","aload_3","iaload","laload","faload","daload","aaload","baload","caload","saload","istore","lstore","fstore","dstore","astore","istore_0","istore_1","istore_2","istore_3","lstore_0","lstore_1","lstore_2","lstore_3","fstore_0","fstore_1","fstore_2","fstore_3","dstore_0","dstore_1","dstore_2","dstore_3","astore_0","astore_1","astore_2","astore_3","iastore","lastore","fastore","dastore","aastore","bastore","castore","sastore","pop","pop2","dup","dup_x1","dup_x2","dup2","dup2_x1","dup2_x2","swap","iadd","ladd","fadd","dadd","isub","lsub","fsub","dsub","imul","lmul","fmul","dmul","idiv","ldiv","fdiv","ddiv","irem","lrem","frem","drem","ineg","lneg","fneg","dneg","ishl","lshl","ishr","lshr","iushr","lushr","iand","land","ior","lor","ixor","lxor","iinc","i2l","i2f","i2d","l2i","l2f","l2d","f2i","f2l","f2d","d2i","d2l","d2f","i2b","i2c","i2s","lcmp","fcmpl","fcmpg","dcmpl","dcmpg","ifeq","ifne","iflt","ifge","ifgt","ifle","if_icmpeq","if_icmpne","if_icmplt","if_icmpge","if_icmpgt","if_icmple","if_acmpeq","if_acmpne","goto","jsr","ret","tableswitch","lookupswitch","ireturn","lreturn","freturn","dreturn","areturn","return","getstatic","putstatic","getfield","putfield","invokevirtual","invokespecial","invokestatic","invokeinterface","invokedynamic","new","newarray","anewarray","arraylength","athrow","checkcast","instanceof","monitorenter","monitorexit","wide","multianewarray","ifnull","ifnonnull","goto_w","jsr_w","breakpoint"],h=function(){function r(e,t,i){if(n(this,r),"number"!=typeof e)throw TypeError("opcode must be a number");if(!Array.isArray(t))throw TypeError("operands must be an array");this.opcode=e,this.operands=t,this.bytecodeOffset=i}return s(r,[{key:"toString",value:function(){var e=f[this.opcode]||(254===this.opcode?"impdep1":255===this.opcode?"impdep2":void 0);return"Instruction { opcode: ".concat(e,", operands: [").concat(this.operands,"] }")}}]),r}(),a=function(){function e(){n(this,e)}return s(e,null,[{key:"toBytecode",value:function(e){if(!Array.isArray(e))throw TypeError("instructions must be an array.");var t=[],i=!0,r=!1,n=void 0;try{for(var s,f=e[Symbol.iterator]();!(i=(s=f.next()).done);i=!0){var a=s.value,o=a.opcode,u=a.operands;if(t.push(o),o===l.default.TABLESWITCH||o===l.default.LOOKUPSWITCH)for(var h=t.length%4?4-t.length%4:0;0<h--;)t.push(0);t.push.apply(t,b(u))}}catch(e){r=!0,n=e}finally{try{i||null==f.return||f.return()}finally{if(r)throw n}}return t}},{key:"fromBytecode",value:function(e){if(!Array.isArray(e))throw TypeError("bytecode must be an array of bytes.");for(var t=[],i=0;i<e.length;){var r=i,n=e[i++],s=void 0;switch(n){case l.default.LOOKUPSWITCH:s=8+8*(e[(i+=i%4?4-i%4:0)+4]<<24|e[i+5]<<16|e[i+6]<<8|e[i+7]);break;case l.default.TABLESWITCH:var f=e[(i+=i%4?4-i%4:0)+4]<<24|e[i+5]<<16|e[i+6]<<8|e[i+7];s=12+4*((e[i+8]<<24|e[i+9]<<16|e[i+10]<<8|e[i+11])-f+1);break;case l.default.WIDE:s=e[i]===l.default.IINC?5:3;break;default:if(void 0===(s=u[n]))throw Error("Unexpected opcode: ".concat(n))}var a=e.slice(i,i+s),o=new h(n,a,r);t.push(o),i+=s}return t}}]),e}()}],n.c=r,n.d=function(e,t,i){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:i})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(t,e){if(1&e&&(t=n(t)),8&e)return t;if(4&e&&"object"==typeof t&&t&&t.__esModule)return t;var i=Object.create(null);if(n.r(i),Object.defineProperty(i,"default",{enumerable:!0,value:t}),2&e&&"string"!=typeof t)for(var r in t)n.d(i,r,function(e){return t[e]}.bind(null,r));return i},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0);function n(e){if(r[e])return r[e].exports;var t=r[e]={i:e,l:!1,exports:{}};return i[e].call(t.exports,t,t.exports,n),t.l=!0,t.exports}var i,r});